unit Unit1;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, FireDAC.Stan.Intf, FireDAC.Stan.Option,
  FireDAC.Stan.Param, FireDAC.Stan.Error, FireDAC.DatS, FireDAC.Phys.Intf,
  FireDAC.DApt.Intf, Data.DB, FireDAC.Comp.DataSet, FireDAC.Comp.Client,
  FlexCel.VCLSupport, FlexCel.Core, FlexCel.XlsAdapter, FlexCel.Render,
  FlexCel.Preview;

type
  TForm1 = class(TForm)
    DetailLeft: TFDMemTable;
    DetailRight: TFDMemTable;
    DetailRightText: TStringField;
    DetailLeftText: TStringField;
    DetailCombo: TFDMemTable;
    StringField1: TStringField;
    DetailComboIsLeft: TBooleanField;
    procedure FormCreate(Sender: TObject);
  private
    { Private-Deklarationen }
    procedure SeedData;
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses FlexCel.Report;

procedure TForm1.FormCreate(Sender: TObject);
begin
  var report := TFlexCelReport.Create(True);
  var ms := TMemoryStream.Create;
  var fs : TFileStream := nil;
  var xls: TXlsFile := nil;
  var fexp: TFlexCelImgExport := nil;

  try
    SeedData;
    report.AddTable('DetailLeft', DetailLeft);
    report.AddTable('DetailRight', DetailRight);
    report.AddTable('DetailCombo', DetailCombo);

    fs := TFileStream.Create('..\..\test.xlsx', fmOpenRead or fmShareDenyNone);
    ms.LoadFromStream(fs);

    xls := TXlsFile.Create(ms, true);
    report.Run(xls);
    xls.Save('..\..\out.xlsx');

  finally
    report.Free;
    fs.Free;
    ms.Free;
    xls.Free;
    fexp.Free;
  end;
end;

procedure TForm1.SeedData;
  procedure Insert(Left: Boolean; Text: String);
  begin
    DetailCombo.InsertRecord([Left, Text]);
    if Left then
      DetailLeft.InsertRecord([Text])
    else
      DetailRight.InsertRecord([Text]);
  end;
begin
  Insert(True, 'Hello');
  Insert(False, 'Line1');
  Insert(False, 'Line2');
  Insert(False, 'Line3');
end;

end.
